{

  Program za ilustraciju efekta 
  3D slagalice, uz tekst '3D SLAGALICA', pc #127.

  Zahvaljujem se Marku  Savkoviu  na  divnoj  slici  koja  se mapira preko
  slagalice, kao i Mrkiju koji je pozirao prilikom fotografisanja iste.

          Gojko Adic, mastermind@sezampro.yu


}
uses dos,crt;
type tip1=array[0..19999] of byte;
     tip2=array[0..63999] of byte;

var z,y,r,x,k,p,slpos:word;
    slika,shema1:^tip1;
    pome1:integer;
   pozadina:^tip2;
   palete:array[1..3*256] of byte;
   f:file;
   i:byte;
   ki:integer;
   mrdanje,amplituda,pomereno:array[0..15] of shortint;
   a1:integer;

  procedure postavipaletu;
  var regs:registers;
   begin
      regs.ah:=$10;
      regs.al:=$12;
      regs.bx:=0;
      regs.cx:=256;
      regs.es:=seg(palete);
      regs.dx:=ofs(palete);
      intr($10,regs);
    end;

 procedure ucitajsliku;
  begin
    assign(f,'C_tv120.r1');
    reset(f,1);
    blockread(f,slika^,100*200);
    blockread(f,palete,3*256);
    close(f);
   end;

  procedure ucitajshemu;
   begin
     assign(f,'shema.r1');
     reset(f,1);
     blockread(f,shema1^,100*200);
     close(f);
    end;

  procedure crtajekran;
  begin
     r:=38329;
     slpos:=19999;
      for y:=99 downto 1 do
       begin
         k:=r;
         for x:=49 downto 0 do
            begin
             for i:=0 to 3 do 
               begin
                pome1:=322*pomereno[shema1^[slpos-i]]+k;
                pozadina^[pome1]:=slika^[slpos-i]; 
                 for a1:=1 to 7 do
                  begin
                   pome1:=pome1-322;
                   pozadina^[pome1]:=1;   { 1 je boja senke }
                   pozadina^[pome1+1]:=1;
                  end;
                k:=k-1;
               end;
             k:=k+320;
             slpos:=slpos-4;
            end;
         r:=r-320;
   end;
   end;

begin

 { inicijalizujemo velike nizove }

 new(slika);
 new(shema1);
 new(pozadina);

 { ucitavamo sliku i shemu }

 ucitajshemu;
 ucitajsliku;

 { postavljamo pocetne vrednosti nizova }

 mrdanje[0]:=0; { ukoliko ima staticnih delova, oni su obojeni nultom bojom }
 for x:=1 to 15 do mrdanje[x]:=1;
 for x:=0 to 15 do amplituda[x]:=16-x;
 for x:=0 to 15 do pomereno[x]:=0;

 
 { prelazimo u 320x200x256 }

 asm
  mov ax,13h
  int 10h
 end;

 postavipaletu;


 { glavna petlja }

 repeat
   fillchar(pozadina^,64000,0);
   crtajekran;
 
   { eventualno cekanje na vertical retrace bi trebalo da dodje ovde }
 
   move(pozadina^,mem[$a000:0],64000);
   for x:=0 to 15 do 
    begin
     if abs(pomereno[x])>amplituda[x] then mrdanje[x]:=-mrdanje[x];
     pomereno[x]:=pomereno[x]+mrdanje[x];
    end;
 until port[$60]=1;
 
 { cistimo memoriju }

 dispose(slika);
 dispose(pozadina);
 dispose(shema1);
 
 { povratak u obicni, dosadni, textmode ;) }

 asm
  mov ax,3
  int 10h
 end;

end.
